//+------------------------------------------------------------------+
//|                                          The market scanner..mq4 |
//|                                        ALVIBU (  )  .  DRAGA |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "ALVIBU (  ) DRAGA "
#property link      ""

#property show_inputs

extern string FileName = "Market scanner";
extern int BarNumber =  500; // -   
extern int FastMAperiod = 5; //   
extern int FastMAtype = MODE_EMA; //   
extern int FastMAprice = PRICE_TYPICAL; //   
extern int SlowMAperiod = 7;
extern int SlowMAtype = MODE_EMA;
extern int SlowMAprice = PRICE_TYPICAL;
int handle;
//+------------------------------------------------------------------+
//| script program start function |
//+------------------------------------------------------------------+
void start()
{
   FileDelete(FileName+".csv");
   handle=FileOpen(FileName+".csv",FILE_CSV|FILE_READ|FILE_WRITE,',');
   FileWrite(handle,
   "",
   "" , 
   "",
  // " ",
  // " ",
   "",
  // "   ",
  // "   ",
  // "   ",
  // "   ",
   "  ",
   " ");
   //      = -   / -   ;
   //     =      .   ;
   //     :  . ,    ;
   //    :  . ,       ;
   //               MT4/experts/files/
   
   FileClose(handle);
//----Calc();Calc();Calc();Calc();

   Calc (("AUDUSD"),5); Calc (("AUDUSD"),15); Calc (("AUDUSD"),60 ); Calc (("AUDUSD"),240 );
   Calc (("EURGBP"),5); Calc (("EURGBP"),15); Calc (("EURGBP"),60 ); Calc (("EURGBP"),240 );
   Calc (("USDCHF"),5); Calc (("USDCHF"),15); Calc (("USDCHF"),60 ); Calc (("USDCHF"),240 );
   Calc (("USDJPY"),5); Calc (("USDJPY"),15); Calc (("USDJPY"),60 ); Calc (("USDJPY"),240 );
   Calc (("EURJPY"),5); Calc (("EURJPY"),15); Calc (("EURJPY"),60 ); Calc (("EURJPY"),240 );
   Calc (("EURUSD"),5); Calc (("EURUSD"),15); Calc (("EURUSD"),60 ); Calc (("EURUSD"),240 );
   Calc (("GBPUSD"),5); Calc (("GBPUSD"),15); Calc (("GBPUSD"),60 ); Calc (("GBPUSD"),240 );
   Calc (("USDCAD"),5); Calc (("USDCAD"),15); Calc (("USDCAD"),60 ); Calc (("USDCAD"),240 );
   
   
//----
  return;
 }
//+------------------------------------------------------------------+
void Calc(string Symb,int TF )
 {
  int i,j,Up,Dn;
  double ma5, ma8, ma5_, ma8_;
  double Delta,DeltaUp, DeltaDn;
  double MaxDeltaUp, MaxDeltaDn;
  double Cross_i, Cross_i1;
  double Pnt=MarketInfo(Symb,MODE_POINT);
  if (Pnt==0.0) return(0);
  int Index[1000];
  
  Up = 0;
  Dn = 0;
  j = 0;
  for (i=0; i<BarNumber; i++) {
  ma5 = iMA(Symb,TF,FastMAperiod,0,FastMAtype,FastMAprice,i);
  ma8 = iMA(Symb,TF,SlowMAperiod,0,SlowMAtype,SlowMAprice,i);
  ma5_ = iMA(Symb,TF,FastMAperiod,0,FastMAtype,FastMAprice,i+1);
  ma8_ = iMA(Symb,TF,SlowMAperiod,0,SlowMAtype,SlowMAprice,i+1);
  if(ma5 > ma8 && ma5_ < ma8_) {Up++;j++;Index[j]=i;}
  if(ma5 < ma8 && ma5_ > ma8_) {Dn++;j++;Index[j]=i;}
 }
  DeltaDn = 0;
  DeltaUp = 0;
  MaxDeltaUp = 0;
  MaxDeltaDn = 0;
  for(i=1; i<=j-1; i++) {
  ma5 = iMA(Symb,TF,FastMAperiod,0,FastMAtype,FastMAprice,Index[i]);
  ma8 = iMA(Symb,TF,SlowMAperiod,0,SlowMAtype,SlowMAprice,Index[i]);
  ma5_ = iMA(Symb,TF,FastMAperiod,0,FastMAtype,FastMAprice,Index[i]+1);
  ma8_ = iMA(Symb,TF,SlowMAperiod,0,SlowMAtype,SlowMAprice,Index[i]+1);

  Cross_i = (ma5+ma8+ma5_+ma8_)/4;
  ma5 = iMA(Symb,TF,FastMAperiod,0,FastMAtype,FastMAprice,Index[i+1]);
  ma8 = iMA(Symb,TF,SlowMAperiod,0,SlowMAtype,SlowMAprice,Index[i+1]);
  ma5_ = iMA(Symb,TF,FastMAperiod,0,FastMAtype,FastMAprice,Index[i+1]+1);
  ma8_ = iMA(Symb,TF,SlowMAperiod,0,SlowMAtype,SlowMAprice,Index[i+1]+1);
  Cross_i1 = (ma5+ma8+ma5_+ma8_)/4;
   
  if(Cross_i < Cross_i1) {
  Delta = (Cross_i1/Pnt-Cross_i/Pnt);
  DeltaDn = DeltaDn + Delta;
  if(Delta > MaxDeltaDn) MaxDeltaDn = Delta;
  }  
  if(Cross_i > Cross_i1) {
  Delta = (Cross_i/Pnt-Cross_i1/Pnt);
  DeltaUp = DeltaUp + Delta;
  if(Delta > MaxDeltaUp) MaxDeltaUp = Delta;
  }  
}
   if(Up!=0.0) DeltaUp = DeltaUp/Up;
   if(Up!=0.0) DeltaDn = DeltaDn/Dn;
//----
  
   double BN=BarNumber;
   if(Up+Dn!=0.0) BN/=Up+Dn;
   else BN=0;
    //   .  
    
   handle=FileOpen(FileName+".csv",FILE_CSV|FILE_READ|FILE_WRITE,',');
   FileSeek(handle,0,SEEK_END);
   FileWrite(handle,
   Symb,
   TF,
   ( Up+Dn),
   //Up,
  // Dn,
    NormalizeDouble((DeltaUp+DeltaDn)/2,2),
  // NormalizeDouble(DeltaUp,2),
  // NormalizeDouble(DeltaDn,2),
  // NormalizeDouble(MaxDeltaUp,2),
  // NormalizeDouble(MaxDeltaDn,2),
    NormalizeDouble(BN,2),
    NormalizeDouble(((DeltaUp+DeltaDn)/2) /BN,2)
   );
   FileClose(handle);
     //   
//----
 //     
    /*
if(Symb==Symbol())
  {
   Comment
   (
   "  -> ",(Up+Dn),"\n",
   "  ,  -> ",NormalizeDouble((DeltaUp+DeltaDn)/2,2),"\n",
   "   -> ",NormalizeDouble(BN,2),"\n",
   "  -> " ,NormalizeDouble(((DeltaUp+DeltaDn)/2) /BN,2)
   );
  }
  return(0);
  */
}